`define NUM_CORE 10

module oc_des_des3perf_top(handsome_clk, handsome_din_top, handsome_dout_top, clk);
	input handsome_clk;
	input handsome_din_top;
	output handsome_dout_top;
	input clk;

localparam input_width = 233;
localparam output_width = 64;
localparam reducer_log4 = 3;
localparam reducer_log4_top = 2;

wire [`NUM_CORE-1:0] decrypt;
wire [63:0] desIn [`NUM_CORE-1:0];
wire [55:0] key1 [`NUM_CORE-1:0];
wire [55:0] key2 [`NUM_CORE-1:0];
wire [55:0] key3 [`NUM_CORE-1:0];
wire [63:0] desOut [`NUM_CORE-1:0];
wire [`NUM_CORE-1:0] handsome_din;
wire [`NUM_CORE-1:0] handsome_dout;

handsome_lfsr #(`NUM_CORE) input_lfsr_top (
			.clock(handsome_clk),
			.input_bit(handsome_din_top),
			.output_vector(handsome_din));

generate
begin:G1
	genvar i;
	for (i = 0; i < `NUM_CORE; i = i+1)
	begin :stamp_inst

		handsome_lfsr #(input_width) input_lfsr (
			.clock(handsome_clk),
			.input_bit(handsome_din[i]),
			.output_vector({decrypt[i],desIn[i],key1[i],key2[i],key3[i]}));

		oc_des_des3perf oc_stamp(
			.clk(clk),
			.decrypt(decrypt[i]),
			.desIn(desIn[i]),
			.key1(key1[i]),
			.key2(key2[i]),
			.key3(key3[i]),
			.desOut(desOut[i]));

		handsome_reducer #(reducer_log4) output_reducer (
			.clock(handsome_clk),
			.input_vector({desOut[i]}),
			.output_bit(handsome_dout[i]));

	end

handsome_reducer #(reducer_log4_top) output_reducer_top (
	.clock(handsome_clk),
	.input_vector(handsome_dout[`NUM_CORE-1:0]),
	.output_bit(handsome_dout_top));

end
endgenerate
endmodule
